import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/mapping/index.ts";
import { pipe, T } from '@contentlayer/utils/effect';
import { getDatabasePropertyData, getPagePropertyData } from '../schema/utils/getPropertyData.js';
import { fieldBool } from './field-bool.js';
import { fieldCreatedBy } from './field-created-by.js';
import { fieldDate } from './field-date.js';
import { fieldDateRange } from './field-date-range.js';
import { fieldFiles } from './field-files.js';
import { fieldFormula } from './field-formula.js';
import { fieldLastEditedBy } from './field-last-edited-by.js';
import { fieldNumber } from './field-number.js';
import { fieldPeople } from './field-people.js';
import { fieldRelation } from './field-relation.js';
import { fieldRichText } from './field-rich-text.js';
import { fieldRollup } from './field-rollup.js';
import { fieldSelect } from './field-select.js';
import { fieldStatus } from './field-status.js';
import { fieldString } from './field-string.js';
const FieldMapping = {
    checkbox: fieldBool,
    email: fieldString,
    phone_number: fieldString,
    select: fieldSelect,
    url: fieldString,
    number: fieldNumber,
    title: fieldRichText,
    created_time: fieldDate,
    status: fieldStatus,
    date: fieldDateRange,
    last_edited_time: fieldDate,
    rich_text: fieldRichText,
    files: fieldFiles,
    people: fieldPeople,
    last_edited_by: fieldLastEditedBy,
    created_by: fieldCreatedBy,
    formula: fieldFormula,
    relation: fieldRelation,
    rollup: fieldRollup,
};
export const getFieldFunctions = (type) => (T.chain_(T.sync(() => FieldMapping[type]), (func) => T.cond_(!!func, () => func, () => 'fail', fileName_1 + ":101:14"), fileName_1 + ":100:12"));
export const getFieldDef = (args) => (T.chain_(getFieldFunctions(args.property.type), (functions) => functions.getFieldDef({
    propertyData: getDatabasePropertyData(args.property),
    ...args,
}), fileName_1 + ":114:12"));
export const getFieldData = (args) => (T.chain_(getFieldFunctions(args.property.type), (functions) => functions.getFieldData({
    propertyData: getPagePropertyData(args.property),
    ...args,
}), fileName_1 + ":127:12"));
//# sourceMappingURL=index.js.map